; haribote-ipl
; TAB=4

CYLS	EQU		9				;  оϱ

		ORG		0x7c00			;  α׷   ΰ

 ϴ ǥ FAT12  ÷ ũ  

		JMP		entry
		DB		0x90
		DB		"HARIBOTE"		; boot sector ̸ Ӱ ᵵ (8Ʈ)
		DW		512			; 1 ũ(512 ؾ )
		DB		1			; Ŭ ũ(1ͷ ؾ )
		DW		1			; FAT 𿡼 ۵ɱ( 1°)
		DB		2			; FAT (2 ؾ )
		DW		224			; Ʈ 丮  ũ( 224Ʈ Ѵ)
		DW		2880			; ̺ ũ(2880ͷ ؾ )
		DB		0xf0			; ̵ Ÿ(0xf0 ؾ )
		DW		9			; FAT (9ͷ ؾ )
		DW		18			; 1Ʈ  Ͱ (18 ؾ )
		DW		2			;  (2 ؾ )
		DD		0			; Ƽ  ʱ   ݵ 0
		DD		2880			; ̺ ũ⸦ ѹ  write
		DB		0,0,0x29		;      θ   
		DD		0xffffffff		; Ƹ,  ø ȣ
		DB		"HARIBOTEOS "		; ũ ̸(11Ʈ)
		DB		"FAT12   "		;  ̸(8Ʈ)
		RESB	18				; 켱 18Ʈ  д

; α׷ ü

entry:
		MOV		AX, 0			;  ʱȭ
		MOV		SS,AX
		MOV		SP,0x7c00
		MOV		DS,AX

; ũ д´

		MOV		AX,0x0820
		MOV		ES,AX
		MOV		CH, 0			; Ǹ 0
		MOV		DH, 0			;  0
		MOV		CL, 2			;  2
		MOV		BX, 18*2*CYLS-1		; о̰  հ ͼ
		CALL	readfast			;  read

;  оǷ haribote.sys ̴!

		MOV		BYTE [0x0ff0], CYLS	; IPL  о ޸
		JMP		0xc200

error:
		MOV		AX,0
		MOV		ES,AX
		MOV		SI,msg
putloop:
		MOV		AL,[SI]
		ADD		SI, 1			; SI 1 Ѵ
		CMP		AL,0
		JE		fin
		MOV		AH, 0x0e		;   ǥ 
		MOV		BX, 15			; Į ڵ
		INT		0x10			;  BIOS ȣ
		JMP		putloop
fin:
		HLT					; ΰ   CPU Ų
		JMP		fin			; endless loop
msg:
		DB		0x0a, 0x0a		;  2
		DB		"load error"
		DB		0x0a			; 
		DB		0

readfast:	; AL     о
;	ES:read , CH:Ǹ, DH:, CL:, BX:read ͼ

		MOV		AX, ES			; < ESκ AL ִġ  >
		SHL		AX, 3			; AX 32 ,   AH   ȴ (SHL left shift )
		AND		AH, 0x7f		; AH AH 128  (512*128=64 K)
		MOV		AL, 128			; AL = 128 - AH;   64KB  ִ 
		SUB		AL,AH

		MOV		AH, BL			; < BXκ AL ִġ AH  >
		CMP		BH, 0			; if (BH ! = 0) { AH = 18; }
		JE		.skip1
		MOV		AH,18
.skip1:
		CMP		AL, AH			; if (AL > AH) { AL = AH; }
		JBE		.skip2
		MOV		AL,AH
.skip2:

		MOV		AH, 19			; < CLκ AL ִġ AH  >
		SUB		AH, CL			; AH = 19 - CL;
		CMP		AL, AH			; if (AL > AH) { AL = AH; }
		JBE		.skip3
		MOV		AL,AH
.skip3:

		PUSH	BX
		MOV		SI, 0			;  ȸ  
retry:
		MOV		AH, 0x02		; AH=0x02 : ũ read
		MOV		BX,0
		MOV		DL, 0x00		; A̺
		PUSH	ES
		PUSH	DX
		PUSH	CX
		PUSH	AX
		INT		0x13			; ũ BIOS ȣ
		JNC		next			;  Ͼ  next
		ADD		SI, 1			; SI 1 Ѵ
		CMP		SI, 5			; SI 5 
		JAE		error			; SI >= 5  error
		MOV		AH,0x00
		MOV		DL, 0x00		; A̺
		INT		0x13			; ̺ Ʈ
		POP		AX
		POP		CX
		POP		DX
		POP		ES
		JMP		retry
next:
		POP		AX
		POP		CX
		POP		DX
		POP		BX			; ES  BX ޴´
		SHR		BX, 5			; BX 16Ʈ  512Ʈ 
		MOV		AH,0
		ADD		BX, AX			; BX += AL;
		SHL		BX, 5			; BX 512Ʈ  16Ʈ 
		MOV		ES, BX			; ̰ ES += AL * 0x20;  ȴ
		POP		BX
		SUB		BX,AX
		JZ		.ret
		ADD		CL, AL			; CL AL Ѵ
		CMP		CL, 18			; CL 18 
		JBE		readfast		; CL <= 18 ̶ readfast
		MOV		CL,1
		ADD		DH,1
		CMP		DH,2
		JB		readfast		; DH < 2  readfast
		MOV		DH,0
		ADD		CH,1
		JMP		readfast
.ret:
		RET

		RESB	0x7dfe-$			; 0x7dfe 0x00 ä 

		DB		0x55, 0xaa
